Attribute VB_Name = "Syllabify"
'Syllabify

'Lightly adapted from an existing independent program; lots of coda sitting around.


'Given a set of words, vowels, and onsets, find the maximal onset syllabification.
'   Detect errors by listing the resulting codas.

Option Explicit

    'For communication with outside world.
        Public mInputForm As String
        Dim mOutputForm As String
        Public mResult As String
    
    
    'Module level variables.
        'Simple word label (phonetic symbols, separated by space):
            Dim mWords() As String
        'Same, parsed into segments:
            Dim mSegments(100) As String
        'Word lengths in segments:
            'Dim mNumberOfSegmentsPerWord() As Long
            Dim mNumberOfSegments As Long
            'Dim mNumberOfVowelsPerWord() As Long
            Dim mNumberOfVowels As Long
            
        'Given by user:
            Dim mVowels() As String
            Dim mOnsets() As String
            
        'Data collected and displayed in output files:
            'Coda collection:
                Dim mCodas() As String
                Dim mCodaExamples() As String
                Dim mNumberOfCodaExamples() As Long
                Dim mCodaFrequencies() As Long
            'Rhyme collection:
                Dim mRhymes() As String
                Dim mRhymeExamples() As String
                Dim mNumberOfRhymeExamples() As Long
                Dim mRhymeFrequencies() As Long
            'Medial clusters:
                Dim mMedialClusters() As String
                Dim mMedialClusterExamples() As String
                Dim mNumberOfMedialClusterExamples() As Long
                Dim mMedialClusterFrequencies() As Long
            'Initial onsets and final codas:
                Dim mInitialOnsets() As String
                Dim mInitialOnsetCounts() As Long
                Dim mNumberOfInitialOnsets As Long
                Dim mFinalCodas() As String
                Dim mFinalCodaCounts() As Long
                Dim mNumberOfFinalCodas As Long
        
        'Counting all of these collected things:
            Dim mNumberOfWords As Long
            Dim mNumberOfVowelTypes As Long
            Dim mNumberOfOnsets As Long
            Dim mNumberOfCodas As Long
            Dim mNumberOfRhymes As Long
            Dim mNumberOfMedialClusters As Long

        'File numbers
            Dim SyllabFile As Long, CodaFile As Long, RhymeFile As Long, MedClustFile As Long
            
        'This is an Easter egg, for marking vowel position from end of the word.
            Dim mMarkOffVowelsFromRightToLeft As Boolean
        
Public Function Syllabified(MyWord As String) As String

    'Use this for accessing this part of the program from the outside.
        Let mInputForm = MyWord
        Call Command1_Click
        Let Syllabified = mOutputForm

End Function

Public Sub ReadSyllabificationFiles()

    Dim MyLine As String
    
    'Read in the vowels.
        Open App.Path + "/FilesNeededForOperation/Vowels.txt" For Input As #1
        Do While Not EOF(1)
            Line Input #1, MyLine
            If Trim(MyLine) <> "" Then
                Let mNumberOfVowelTypes = mNumberOfVowelTypes + 1
                ReDim Preserve mVowels(mNumberOfVowelTypes)
                Let mVowels(mNumberOfVowelTypes) = Trim(MyLine)
            End If
        Loop
        Close #1
    
    'Read in the list of legal onsets.
        Open App.Path + "/FilesNeededForOperation/Onsets.txt" For Input As #1
        Do While Not EOF(1)
            Line Input #1, MyLine
            If Trim(MyLine) <> "" Then
                Let mNumberOfOnsets = mNumberOfOnsets + 1
                ReDim Preserve mOnsets(mNumberOfOnsets)
                Let mOnsets(mNumberOfOnsets) = Trim(MyLine)
            End If
        Loop
        Close #1

End Sub

Private Sub Command1_Click()

    'Procedure-level variables:
        'Being worked on (one word)
            Dim MyLine As String, Buffer As String
        'What you are looking for during the parse.
            Dim SearchState As Long
                Const SeekingCoda As Long = 1
                Const SeekingNucleus As Long = 2
                Const SeekingOnset As Long = 3
        'Buffer for holding a coda
            Dim MyCoda As String
        'You need to remember the previous coda for when there is hiatus.
            Dim OldCoda As String
        'Buffer for holding a rhyme
            Dim MyRhyme As String
        'Buffer for holding a medial cluster
            Dim MyMedialCluster As String
        'The syllable parse expressed as onsets and rhyme affiliations
            Dim OnsetsAndRhymes As String
        'Index of an already-known coda in the accumulating list; ditto for medial cluster
            Dim IndexOfFoundCoda As Long
        'For counting all initial sequences as onsets.
            Dim InputBuffer As String, OutputBuffer As String
            Dim MySegment As String
        'Indices
            Dim WordIndex As Long, SegmentIndex As Long, CodaIndex As Long, MedialClusterIndex As Long, RhymeIndex As Long
        'For the interface
            Static ButtonStatus As Boolean
        'Files
            Dim InFile As Long
        
    'Second time around this is an exit button.
    '    If ButtonStatus = True Then End
    '    Let ButtonStatus = True
        
        
    'Call OpenOutputFiles
    
    'Go through all the words and syllabify them, recording codas as a means of checking error.
    'This use:  just the one word mInputForm
        
        'Let InFile = FreeFile
        'Open App.Path + "/in.txt" For Input As #InFile
        'Do While Not EOF(InFile)
            'Line Input #InFile, MyLine
            Let MyLine = mInputForm
            Let MyLine = Trim(MyLine)
            
        'Find the segments
            Let Buffer = MyLine
            'If MyLine = "? ? ?" Then Stop
            Let mNumberOfSegments = 0
            Let mNumberOfVowels = 0
            Do
                If Buffer = "" Then Exit Do
                Let mNumberOfSegments = mNumberOfSegments + 1
                Let mSegments(mNumberOfSegments) = s.CustomChomp(Buffer, " ")
                Let Buffer = Trim(s.CustomResidue(Buffer, " "))
            Loop
        
        
        'For WordIndex = 1 To mNumberOfWords
                            
            'Collect these before they get messed up by parsing periods.
                'Call CollectInitialOnsetsAndCodas(WordIndex)
                Call CollectInitialOnsetsAndCodas(MyLine)
        
            Let OldCoda = ""
            'Report progress.
            '    Let WordIndex = WordIndex + 1
            '    If WordIndex / 1000 = Int(WordIndex / 1000) Then
            '        Let Command1.Caption = "Syllabifying word #" + Trim(Str(WordIndex)) + " ..."
            '    End If
            'Initialize the variable that stores the parse as onset and rhyme affiliations.
                Let OnsetsAndRhymes = ""
            'Always begin the right-to-left search by looking for a coda.
                Let SearchState = SeekingCoda
            'Initialize the variables that accumulate codas and medial clusters.
                Let MyCoda = ""
                Let MyMedialCluster = ""
            'Scan the word right to left.
                'For SegmentIndex = mNumberOfSegmentsPerWord(WordIndex) To 1 Step -1
                For SegmentIndex = mNumberOfSegments To 1 Step -1
                    If SearchState = SeekingCoda Then
                        If IsVowel(mSegments(SegmentIndex)) Then
                            'Augment the number of vowels.
                                Let mNumberOfVowels = mNumberOfVowels + 1
                            'Now we have a coda on our hands, perhaps null.  Process this information.
                                Call DealWithFoundCoda(MyCoda, MyLine)
                            'Also, if we didn't just find the word-final coda, we have a new medial cluster on our hands.
                                If mNumberOfVowels > 1 Then
                                    Call ProcessMedialCluster(MyMedialCluster, MyLine)
                                End If
                            'Deal with the rhyme in analogous fashion.
                                Let MyRhyme = mSegments(SegmentIndex) + " " + MyCoda
                                Call ProcessRhyme(MyRhyme, MyLine)
                            'Mark the segment just parsed as a nucleus (no mark):
                                'Do an extra bit if the user wants vowels marked off from right to left.
                                    If mMarkOffVowelsFromRightToLeft Then
                                        Let OnsetsAndRhymes = mSegments(SegmentIndex) + VowelSequenceMarker(mNumberOfVowels) + " " + OnsetsAndRhymes
                                    Else
                                        Let OnsetsAndRhymes = mSegments(SegmentIndex) + " " + OnsetsAndRhymes
                                    End If
                                
                            'Reinitialize the medial cluster-accumulating variables.
                                Let OldCoda = MyCoda
                                Let MyCoda = ""
                                Let MyMedialCluster = ""
                            'Switch to seeking onsets
                                Let SearchState = SeekingOnset
                        Else
                            'It's not a vowel.  So simply augment the accumulating coda and medial cluster:
                                Let MyCoda = mSegments(SegmentIndex) + " " + MyCoda
                                Let MyMedialCluster = mSegments(SegmentIndex) + " " + MyMedialCluster
                            'Mark the segment just parsed as a coda:
                                Let OnsetsAndRhymes = mSegments(SegmentIndex) + "Coda " + OnsetsAndRhymes
                        End If
                    Else
                        'The SearchState is *not* "seeking coda", so instead look for an onset.
                            If SegmentIndex >= 3 Then
                                'Triple onset:
                                    If IsOnset(mSegments(SegmentIndex - 2) + " " + mSegments(SegmentIndex - 1) + " " + mSegments(SegmentIndex)) Then
                                        'Mark the segments just parsed as onset segments:
                                            Let OnsetsAndRhymes = mSegments(SegmentIndex - 2) + " " + mSegments(SegmentIndex - 1) + " " + mSegments(SegmentIndex) + " " + OnsetsAndRhymes
                                        'Add these segments to the accumulating medial cluster.
                                            Let MyMedialCluster = mSegments(SegmentIndex - 2) + " " + mSegments(SegmentIndex - 1) + " " + mSegments(SegmentIndex) + " " + MyMedialCluster
                                        'Add a syllable break.
                                            Let mSegments(SegmentIndex - 2) = ". " + mSegments(SegmentIndex - 2)
                                        'Shift the index to skip
                                            Let SegmentIndex = SegmentIndex - 2
                                        'Since you found an onset (perhaps null), you are now looking for a coda
                                            Let SearchState = SeekingCoda
                                            Let MyCoda = ""
                                        'Skip the other options (thus implementing the maximal onset principle.
                                            GoTo ExitPoint
                                    End If
                            End If
                            If SegmentIndex >= 2 Then
                                'Double onset:
                                    If IsOnset(mSegments(SegmentIndex - 1) + " " + mSegments(SegmentIndex)) Then
                                        'Mark the segments just parsed as onset segments:
                                            Let OnsetsAndRhymes = mSegments(SegmentIndex - 1) + " " + mSegments(SegmentIndex) + " " + OnsetsAndRhymes
                                        'Add these segments to the accumulating medial cluster.
                                            Let MyMedialCluster = mSegments(SegmentIndex - 1) + " " + mSegments(SegmentIndex) + " " + MyMedialCluster
                                        'Add a syllable break.
                                            Let mSegments(SegmentIndex - 1) = ". " + mSegments(SegmentIndex - 1)
                                        'Shift the index to skip
                                            Let SegmentIndex = SegmentIndex - 1
                                        'Since you found an onset (perhaps null), you are now looking for a coda
                                            Let SearchState = SeekingCoda
                                            Let MyCoda = ""
                                        'Skip the other options.
                                            GoTo ExitPoint
                                    End If
                            End If
                            If SegmentIndex >= 1 Then
                                'Single onset:
                                    If IsOnset(mSegments(SegmentIndex)) Then
                                        'Mark the segment just parsed as an onset segment:
                                            Let OnsetsAndRhymes = mSegments(SegmentIndex) + " " + OnsetsAndRhymes
                                        'Add this segment to the accumulating medial cluster.
                                            Let MyMedialCluster = mSegments(SegmentIndex) + " " + MyMedialCluster
                                        'Add a syllable break.
                                            Let mSegments(SegmentIndex) = ". " + mSegments(SegmentIndex)
                                        'Since you found an onset (perhaps null), you are now looking for a coda
                                            Let SearchState = SeekingCoda
                                            Let MyCoda = ""
                                        'Skip the other options.
                                            GoTo ExitPoint
                                    End If
                            End If
                            'You haven't found any onset at all, so this must be either hiatus or something like V NG V.
                                'The syllable break gets added to the following vowel.
                                    Let mSegments(SegmentIndex + 1) = ". " + mSegments(SegmentIndex + 1)
                                'Specify how much of the coda you already have.
                                    If IsVowel(mSegments(SegmentIndex)) Then
                                        'This is the case of hiatus.
                                            'Augment the number of vowels in this word.  hithere
                                                Let mNumberOfVowels = mNumberOfVowels + 1
                                                'Let mNumberOfVowelsPerWord(WordIndex) = mNumberOfVowelsPerWord(WordIndex) + 1
                                            'Mark the vowel you just parsed as a rhyme segment, with null diacritic:
                                                If mMarkOffVowelsFromRightToLeft Then
                                                    Let OnsetsAndRhymes = mSegments(SegmentIndex) + VowelSequenceMarker(mNumberOfVowels) + " " + OnsetsAndRhymes
                                                Else
                                                    Let OnsetsAndRhymes = mSegments(SegmentIndex) + " " + OnsetsAndRhymes
                                                End If
                                            'We do *not* change search status -- we're still looking for an onset, only further to the left.
                                                Let MyCoda = ""
                                        'What you have just parsed is a rhyme (trim off the period).
                                            Let MyRhyme = mSegments(SegmentIndex)
                                            'Call ProcessRhyme(MyRhyme)
                                            Call ProcessRhyme(MyRhyme, MyLine)
                                    Else
                                        'In V NG V cases, you now have the last segment of the coda, which you should continue looking for.
                                            'Mark the segment just parsed as a rhyme segment:
                                                Let OnsetsAndRhymes = mSegments(SegmentIndex) + "Coda " + OnsetsAndRhymes
                                            Let SearchState = SeekingCoda
                                            Let MyCoda = mSegments(SegmentIndex)
                                            Let MyMedialCluster = mSegments(SegmentIndex)
                                    End If
ExitPoint:
                    
                    End If              'Are you looking for a coda or an onset?
                
                                
                Next SegmentIndex       'End of scanning loop (for one particular word)
            
            'You've parsed the word.
                'Check for residues and mark them as ungrammatical.
                    If SearchState = SeekingCoda And MyCoda <> "" Then
                        Let mSegments(1) = "xxx" + mSegments(1)
                        'These cases (which will arise in the test items) will have fake word-initial codas which have to be trimmed back.
                            Let InputBuffer = OnsetsAndRhymes
                            Let OutputBuffer = ""
                            Do
                                Let MySegment = s.CustomChomp(InputBuffer, " ")
                                If IsVowel(MySegment) Then
                                    Let OutputBuffer = OutputBuffer + InputBuffer
                                    Exit Do
                                ElseIf Right(MySegment, 4) = "Coda" Then
                                    Let OutputBuffer = OutputBuffer + Left(MySegment, Len(MySegment) - 4) + " "
                                Else
                                    OutputBuffer = OutputBuffer + MySegment + " "
                                End If
                                Let InputBuffer = s.CustomResidue(InputBuffer, " ")
                                If Trim(InputBuffer) = "" Then Exit Do
                            Loop
                            Let OnsetsAndRhymes = Trim(OutputBuffer)
                            
                    End If
                    
                'Transfer the result for the present one-time-only use.
                    Let mOutputForm = OnsetsAndRhymes
                    
                'Print the result
                '    'Original string.
                '        'Print #SyllabFile, mWords(WordIndex); Chr(9);
                '        Print #SyllabFile, MyLine; Chr(9);
                '    'Syllabified result.
                '        'For SegmentIndex = 1 To mNumberOfSegmentsPerWord(WordIndex)
                '        For SegmentIndex = 1 To mNumberOfSegments
                '            Print #SyllabFile, " " + Trim(mSegments(SegmentIndex));
                '        Next SegmentIndex
                '    'The classification into onsets and rhymes.
                '        Print #SyllabFile, Chr(9); Trim(OnsetsAndRhymes);
                '    'Word length, in case it is useful.
                '        'Print #SyllabFile, Chr(9); mNumberOfSegmentsPerWord(WordIndex);
                '        Print #SyllabFile, Chr(9); mNumberOfSegments;
                '    'Number of vowels
                '        'Print #SyllabFile, Chr(9); mNumberOfVowelsPerWord(WordIndex)
                '        Print #SyllabFile, Chr(9); mNumberOfVowels
        
        'Next WordIndex
        'Loop
        
        
        'Print the codas you found
         '   For CodaIndex = 1 To mNumberOfCodas
         '       Print #CodaFile, mCodas(CodaIndex); Chr(9); mCodaFrequencies(CodaIndex); Chr(9); mCodaExamples(CodaIndex)
         '   Next CodaIndex
        'Print the rhymes you found
        '    For RhymeIndex = 1 To mNumberOfRhymes
        '        Print #RhymeFile, mRhymes(RhymeIndex); Chr(9); mRhymeFrequencies(RhymeIndex); Chr(9); mRhymeExamples(RhymeIndex)
        '    Next RhymeIndex
        'Print the medial clusters you found
        '    For MedialClusterIndex = 1 To mNumberOfMedialClusters
        '        Print #MedClustFile, mMedialClusters(MedialClusterIndex); Chr(9); mMedialClusterFrequencies(MedialClusterIndex); Chr(9); mMedialClusterExamples(MedialClusterIndex)
        '    Next MedialClusterIndex
            
        'Analyze the medial clusters as concatenations of initial and final clusters (testing a new principle of predicting syllabification.)
         '   Call ParseMedialClusters
            
        'Close output files.
        '    Close
        
        'Announce completion.
        '    Let Command1.Caption = "Done!  Click again to exit."
        
End Sub

Sub DealWithFoundCoda(MyCoda As String, MyLine As String)

    'You've parsed a coda, so process this information.
    
    Dim IndexOfFoundCoda As Long
    
    Let IndexOfFoundCoda = AlreadyFoundCoda(MyCoda)
    If IndexOfFoundCoda > 0 Then
        'Record up to ten examples of it, separated by tabs.
            If mNumberOfCodaExamples(IndexOfFoundCoda) <= 10 Then
                'Let mCodaExamples(IndexOfFoundCoda) = mCodaExamples(IndexOfFoundCoda) + Chr(9) + mWords(WordIndex)
                Let mCodaExamples(IndexOfFoundCoda) = mCodaExamples(IndexOfFoundCoda) + Chr(9) + MyLine
            End If
            Let mNumberOfCodaExamples(IndexOfFoundCoda) = mNumberOfCodaExamples(IndexOfFoundCoda) + 1
    Else
        'It's a new coda.
            'Make a slot for it and record it.
                Let mNumberOfCodas = mNumberOfCodas + 1
                ReDim Preserve mCodas(mNumberOfCodas)
                Let mCodas(mNumberOfCodas) = MyCoda
            'Start the list of example words for this coda.
                ReDim Preserve mCodaExamples(mNumberOfCodas)
                'Let mCodaExamples(mNumberOfCodas) = mWords(WordIndex)
                Let mCodaExamples(mNumberOfCodas) = MyLine
                ReDim Preserve mNumberOfCodaExamples(mNumberOfCodas)
                Let mNumberOfCodaExamples(mNumberOfCodas) = 1
            'Start the frequency count with the value 1.
                ReDim Preserve mCodaFrequencies(mNumberOfCodas)
                Let mCodaFrequencies(mNumberOfCodas) = 1
    End If
End Sub


Sub OpenOutputFiles()
    
    'Open the output files
        
    On Error GoTo ErrorPoint
        
    'Main output file with syllabification:
        Let SyllabFile = FreeFile
        'Open App.Path + "/Syllabified.txt" For Output As #SyllabFile
        'Print a header
            Print #SyllabFile, "Word"; Chr(9); "Syllabified"; Chr(9); "Onset/Rhyme"; Chr(9); "Word Length"; Chr(9); "Syllable Count"
    'List of codas:
        Let CodaFile = FreeFile
        'Open App.Path + "/Codas.txt" For Output As #CodaFile
        'Print a header.
            Print #CodaFile, "Coda"; Chr(9); "Frequency"; Chr(9); "Examples"
    'List of rhymes:
        Let RhymeFile = FreeFile
        'Open App.Path + "/Rhymes.txt" For Output As #RhymeFile
        'Print a header.
            Print #RhymeFile, "Rhyme"; Chr(9); "Frequency"; Chr(9); "Examples"
    'List of codas:
        Let MedClustFile = FreeFile
        'Open App.Path + "/MedialClusters.txt" For Output As #MedClustFile
        'Print a header.
            Print #MedClustFile, "Medial cluster"; Chr(9); "Frequency"; Chr(9); "Examples"
    Exit Sub
    
ErrorPoint:

    If Err.Number = 70 Then
        MsgBox "It appears that one of the files Syllabified.txt, Codas.txt, or MedialClusters.txt is open in some other program.  Please close this file, then click OK to continue."
        Resume
    Else
        MsgBox "Program error.  Please contact Bruce Hayes at bhayes@humnet.ucla.edu."
    End If
    
End Sub

'Sub ProcessMedialCluster(MyMedialCluster As String, WordIndex As Long)
Sub ProcessMedialCluster(MyMedialCluster As String, MyWord As String)

    Dim IndexOfFoundMedialCluster As Long

    'Look up the medial cluster.
        Let IndexOfFoundMedialCluster = AlreadyFoundMedialCluster(MyMedialCluster)
        'Is it new?
            If IndexOfFoundMedialCluster > 0 Then
                'It's not new.
                'Record up to ten examples of it, separated by tabs.
                    If mNumberOfMedialClusterExamples(IndexOfFoundMedialCluster) <= 10 Then
                        'Let mMedialClusterExamples(IndexOfFoundMedialCluster) = mMedialClusterExamples(IndexOfFoundMedialCluster) + Chr(9) + mWords(WordIndex)
                        Let mMedialClusterExamples(IndexOfFoundMedialCluster) = mMedialClusterExamples(IndexOfFoundMedialCluster) + Chr(9) + MyWord
                    End If
                    Let mNumberOfMedialClusterExamples(IndexOfFoundMedialCluster) = mNumberOfMedialClusterExamples(IndexOfFoundMedialCluster) + 1
            Else
                'It's a new medial cluster
                    'Make a slot for it and record it.
                        Let mNumberOfMedialClusters = mNumberOfMedialClusters + 1
                        ReDim Preserve mMedialClusters(mNumberOfMedialClusters)
                        Let mMedialClusters(mNumberOfMedialClusters) = MyMedialCluster
                    'Start the list of example words for this medial cluster.
                        ReDim Preserve mMedialClusterExamples(mNumberOfMedialClusters)
                        'Let mMedialClusterExamples(mNumberOfMedialClusters) = mWords(WordIndex)
                        Let mMedialClusterExamples(mNumberOfMedialClusters) = MyWord
                        ReDim Preserve mNumberOfMedialClusterExamples(mNumberOfMedialClusters)
                        Let mNumberOfMedialClusterExamples(mNumberOfMedialClusters) = 1
                    'Start the frequency count with the value 1.
                        ReDim Preserve mMedialClusterFrequencies(mNumberOfMedialClusters)
                        Let mMedialClusterFrequencies(mNumberOfMedialClusters) = 1
            End If

End Sub

'Sub ProcessRhyme(MyRhyme As String, WordIndex As Long)
Sub ProcessRhyme(MyRhyme As String, MyWord As String)

    Dim IndexOfFoundRhyme As Long

    'Look up the rhyme.
        Let IndexOfFoundRhyme = AlreadyFoundRhyme(MyRhyme)
        'Is it new?
            If IndexOfFoundRhyme > 0 Then
                'It's not new.
                'Record up to ten examples of it, separated by tabs.
                    If mNumberOfRhymeExamples(IndexOfFoundRhyme) <= 10 Then
                        'Let mRhymeExamples(IndexOfFoundRhyme) = mRhymeExamples(IndexOfFoundRhyme) + Chr(9) + mWords(WordIndex)
                        Let mRhymeExamples(IndexOfFoundRhyme) = mRhymeExamples(IndexOfFoundRhyme) + Chr(9) + MyWord
                    End If
                    Let mNumberOfRhymeExamples(IndexOfFoundRhyme) = mNumberOfRhymeExamples(IndexOfFoundRhyme) + 1
            Else
                'It's a new rhyme.
                    'Make a slot for it and record it.
                        Let mNumberOfRhymes = mNumberOfRhymes + 1
                        ReDim Preserve mRhymes(mNumberOfRhymes)
                        Let mRhymes(mNumberOfRhymes) = MyRhyme
                    'Start the list of example words for this medial cluster.
                        ReDim Preserve mRhymeExamples(mNumberOfRhymes)
                        'Let mRhymeExamples(mNumberOfRhymes) = mWords(WordIndex)
                        Let mRhymeExamples(mNumberOfRhymes) = MyWord
                        ReDim Preserve mNumberOfRhymeExamples(mNumberOfRhymes)
                        Let mNumberOfRhymeExamples(mNumberOfRhymes) = 1
                    'Start the frequency count with the value 1.
                        ReDim Preserve mRhymeFrequencies(mNumberOfRhymes)
                        Let mRhymeFrequencies(mNumberOfRhymes) = 1
            End If

End Sub

Function IsVowel(MySegment) As Boolean
    Dim i As Long
    For i = 1 To mNumberOfVowelTypes
        If MySegment = mVowels(i) Then
            Let IsVowel = True
            Exit Function
        End If
        'If you are labeling vowels for position (Italian study), then you have to look for the four types of vowel (X, Y, Z, W).
        '    If chkCountVowelsFromRightToLeft.Value = vbChecked Then
        '        Select Case MySegment
        '            Case mVowels(i) + "X", mVowels(i) + "Y", mVowels(i) + "Z", mVowels(i) + "W"
        '                Let IsVowel = True
        '                Exit Function
        '        End Select
        '    End If
    Next i
    Let IsVowel = False
End Function

Function IsOnset(MyString) As Boolean
    Dim i As Long
    For i = 1 To mNumberOfOnsets
        If MyString = mOnsets(i) Then
            Let IsOnset = True
            Exit Function
        End If
    Next i
    Let IsOnset = False
End Function

Function AlreadyFoundCoda(MyCoda As String) As Long
    Dim i
    For i = 1 To mNumberOfCodas
        If MyCoda = mCodas(i) Then
            Let AlreadyFoundCoda = i
            'Keep track of how many.
                Let mCodaFrequencies(i) = mCodaFrequencies(i) + 1
            Exit Function
        End If
    Next i
    Let AlreadyFoundCoda = 0
End Function

Function AlreadyFoundMedialCluster(MyMedialCluster As String) As Long
    Dim i
    For i = 1 To mNumberOfMedialClusters
        If MyMedialCluster = mMedialClusters(i) Then
            Let AlreadyFoundMedialCluster = i
            'Keep track of how many.
                Let mMedialClusterFrequencies(i) = mMedialClusterFrequencies(i) + 1
            Exit Function
        End If
    Next i
    Let AlreadyFoundMedialCluster = 0
End Function
Function AlreadyFoundRhyme(MyRhyme As String) As Long
    Dim i
    For i = 1 To mNumberOfRhymes
        If MyRhyme = mRhymes(i) Then
            Let AlreadyFoundRhyme = i
            'Keep track of how many.
                Let mRhymeFrequencies(i) = mRhymeFrequencies(i) + 1
            Exit Function
        End If
    Next i
    Let AlreadyFoundRhyme = 0
End Function
Private Sub mnuHelp_Click()
    Dim LE As String
    
    Let LE = Chr(13) + Chr(10) + Chr(13) + Chr(10)
    
    MsgBox "The purpose of this program is to assign syllabification to phonetically-transcribed strings." + _
    LE + "The program assumes you have an input file called in.txt, placed in the same folder as the program itself.  " + _
    "Each line of in.txt is a word consisting of segments, and the segments of the word are separated by spaces.  " + _
    "Segments may be depicted by more than one ASCII character, so that, e.g. thrush might be something like TH R UH SH. " + _
    LE + "You must also have a file called Vowels.txt, with all of the vowels of the language (one vowel symbol per line); and " + _
    "a file called Onsets.txt, with one legal onset (same symbols, separated by single space) per line. " + _
    LE + "The program output is placed in the same folder as the program itself, and consists of two files:  Syllabified.txt (the words syllabified) and Codas.txt " + _
    "(the coda inventory implied by the syllabification).  Strange codas in Codas.txt or xxx in Syllabified.txt diagnose errors in one of the three input files.  " + _
    LE + "Bug and queries:  Bruce Hayes at bhayes@humnet.ucla.edu."
  
End Sub
'Sub CollectInitialOnsetsAndCodas(WordIndex As Long)
Sub CollectInitialOnsetsAndCodas(MyWord As String)

    Dim MyInitialOnset As String, MyFinalCoda As String
    Dim Buffer As String
    Dim PositionIndex As Long, InitialOnsetIndex As Long, FinalCodaIndex As Long
    
    'For PositionIndex = 1 To mNumberOfSegmentsPerWord(WordIndex)
    For PositionIndex = 1 To Len(MyWord)
        If IsVowel(mSegments(PositionIndex)) Then
            Let MyInitialOnset = Trim(Buffer)
            Let Buffer = ""
            'Install what you've gathered.
                For InitialOnsetIndex = 1 To mNumberOfInitialOnsets
                    If MyInitialOnset = mInitialOnsets(InitialOnsetIndex) Then
                        'Augment frequency
                            Let mInitialOnsetCounts(InitialOnsetIndex) = mInitialOnsetCounts(InitialOnsetIndex) + 1
                            GoTo ExitPoint1
                    End If
                Next InitialOnsetIndex
                'It's a new one.
                    Let mNumberOfInitialOnsets = mNumberOfInitialOnsets + 1
                    ReDim Preserve mInitialOnsets(mNumberOfInitialOnsets)
                    ReDim Preserve mInitialOnsetCounts(mNumberOfInitialOnsets)
                    Let mInitialOnsets(mNumberOfInitialOnsets) = MyInitialOnset
                    Let mInitialOnsetCounts(mNumberOfInitialOnsets) = 1
                    GoTo ExitPoint1
        Else
            'Not a vowel.  Augment the onset.
                Let Buffer = Buffer + " " + mSegments(PositionIndex)
        End If
    Next PositionIndex
ExitPoint1:
            
            
    For PositionIndex = mNumberOfSegments To 1 Step -1
    'For PositionIndex = mNumberOfSegmentsPerWord(WordIndex) To 1 Step -1
        If IsVowel(mSegments(PositionIndex)) Then
            Let MyFinalCoda = Trim(Buffer)
            Let Buffer = ""
            'Install what you've gathered.
                For FinalCodaIndex = 1 To mNumberOfFinalCodas
                    If MyFinalCoda = mFinalCodas(FinalCodaIndex) Then
                        'Augment frequency
                            Let mFinalCodaCounts(FinalCodaIndex) = mFinalCodaCounts(FinalCodaIndex) + 1
                            GoTo ExitPoint2
                    End If
                Next FinalCodaIndex
                'It's a new one.
                    Let mNumberOfFinalCodas = mNumberOfFinalCodas + 1
                    ReDim Preserve mFinalCodas(mNumberOfFinalCodas)
                    ReDim Preserve mFinalCodaCounts(mNumberOfFinalCodas)
                    Let mFinalCodas(mNumberOfFinalCodas) = MyFinalCoda
                    Let mFinalCodaCounts(mNumberOfFinalCodas) = 1
                    GoTo ExitPoint2
        Else
            'Not a vowel.  Augment the onset.
                Let Buffer = mSegments(PositionIndex) + " " + Buffer
        End If
    Next PositionIndex
ExitPoint2:
            
    
End Sub

Sub ParseMedialClusters()

    Dim MyInitialOnset As String, MyFinalCoda As String, TargetMedialCluster As String
    Dim InitialOnsetIndex As Long, FinalCodaIndex As Long, MedialClusterIndex As Long
    
    Dim i As Long
    
    'List the initial and final clusters for reference.
        Dim InitialOnsetFile As Long
        Let InitialOnsetFile = FreeFile
        'Open App.Path + "/InitialOnsets.txt" For Output As #InitialOnsetFile
        For i = 1 To mNumberOfInitialOnsets
            Print #InitialOnsetFile, mInitialOnsets(i); Chr(9); mInitialOnsetCounts(i)
        Next i

        Dim FinalCodaFile As Long
        Let FinalCodaFile = FreeFile
        'Open App.Path + "/FinalCodas.txt" For Output As #FinalCodaFile
        For i = 1 To mNumberOfFinalCodas
            Print #FinalCodaFile, mFinalCodas(i); Chr(9); mFinalCodaCounts(i)
        Next i
        
    'Parse the medial clusters
        Dim ParsedMedialClusterFile As Long
        Let ParsedMedialClusterFile = FreeFile
        'Open App.Path + "/ParseMedialClusters.txt" For Output As ParsedMedialClusterFile
        For InitialOnsetIndex = 1 To mNumberOfInitialOnsets
            Let MyInitialOnset = mInitialOnsets(InitialOnsetIndex)
            For FinalCodaIndex = 1 To mNumberOfFinalCodas
                Let MyFinalCoda = mFinalCodas(FinalCodaIndex)
                    Let TargetMedialCluster = Trim(MyFinalCoda + " " + MyInitialOnset)
                    For MedialClusterIndex = 1 To mNumberOfMedialClusters
                        If Trim(mMedialClusters(MedialClusterIndex)) = TargetMedialCluster Then
                            Print #ParsedMedialClusterFile, TargetMedialCluster; Chr(9);
                            Print #ParsedMedialClusterFile, mMedialClusterFrequencies(MedialClusterIndex); Chr(9);
                            Print #ParsedMedialClusterFile, MyFinalCoda; Chr(9);
                            Print #ParsedMedialClusterFile, mFinalCodaCounts(FinalCodaIndex); Chr(9);
                            Print #ParsedMedialClusterFile, MyInitialOnset; Chr(9);
                            Print #ParsedMedialClusterFile, mInitialOnsetCounts(InitialOnsetIndex)
                        End If
                    Next MedialClusterIndex
            Next FinalCodaIndex
        Next InitialOnsetIndex
        
        Close
        
End Sub

Function VowelSequenceMarker(VowelCount As Long) As String
    'We want vowels to be marked according to position from the end.
        Select Case VowelCount
            Case 1
                Let VowelSequenceMarker = "Z"
            Case 2
                Let VowelSequenceMarker = "Y"
            Case 3
                Let VowelSequenceMarker = "X"
            Case Else
                Let VowelSequenceMarker = "W"
        End Select
            
End Function


